using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MyNamespace
{
	/// <summary>
	///		Goldbach - Goldbach's Conjecture - Startup
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class StartupForm : System.Windows.Forms.Form
	{
		private Button buttonDefault;
		private Button buttonExit;
		private Button buttonRun;
		private Label labelCyc;
		private Label labelJLim;
		private Label labelPri;
		private Label labelQSize;
		private Label labelRSize;
		private RichTextBox richTextIntro;
		private TextBox textBoxCyc;
		private TextBox textBoxJLim;
		private TextBox textBoxPri;
		private TextBox textBoxQSize;
		private TextBox textBoxRSize;
		/// <summary>
		///	Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public StartupForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			Global.SetPriority(-1);
			SetDefault();
			Global.GetAssemblyAttributes();
			Global.programURL = "http://www.geocities.com/hjsmithh/Goldbach/";
			Pr ("");
			Pr ("   " + Global.name1);
			Pr ("   " + Global.name2);
			Pr ("   " + Global.version);
			Pr ("   " + Global.author);
			Pr ("   " + Global.address);
			Pr ("");
			Pr ("This program computes terms for The On-Line Encyclopedia of Integer");
			Pr ("Sequences maintained by N. J. A. Sloane. See:");
			Pr ("   http://www.research.att.com/~njas/sequences/");
			Pr ("");
			Pr ("The sequence generates is:");
			Pr ("A135733 1,6,34,64,76,94,166,199,244,244,316,346,496,496,556,556,556,706,706,");
			Pr ("724,724,859,1024,1024,1024,1024,1126,1336,1336,1468,1468,1468,1489,");
			Pr ("1489,1489,1546,1609,1609,1636,1648,1816,1877,1877,2011,2029,2206,2224,...");
			Pr ("");
			Pr ("For every integer m > a(n), 2m can be decomposed into at least n unordered sums");
			Pr ("of two primes. Goldbach's conjecture is equivalent to the case when n = 1, a(1)");
			Pr ("= 1, but for large n there appears to be many decompositions guaranteed. This");
			Pr ("sequence relies on a heuristic calculation and there is no proof that it is");
			Pr ("correct.");
			Pr ("");
			Pr("See: http://mathworld.wolfram.com/GoldbachConjecture.html");
			Pr ("");
			Pr ("The latest version of this program and all of its source files can be");
			Pr ("downloaded from " + Global.programURL + " .");
			this.Text = Global.title + " - Startup";
		}

		/// <summary>
		///	Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StartupForm));
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonRun = new System.Windows.Forms.Button();
			this.richTextIntro = new System.Windows.Forms.RichTextBox();
			this.labelQSize = new System.Windows.Forms.Label();
			this.labelRSize = new System.Windows.Forms.Label();
			this.labelJLim = new System.Windows.Forms.Label();
			this.textBoxQSize = new System.Windows.Forms.TextBox();
			this.textBoxRSize = new System.Windows.Forms.TextBox();
			this.textBoxJLim = new System.Windows.Forms.TextBox();
			this.labelCyc = new System.Windows.Forms.Label();
			this.textBoxCyc = new System.Windows.Forms.TextBox();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.textBoxPri = new System.Windows.Forms.TextBox();
			this.labelPri = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonExit
			// 
			this.buttonExit.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonExit.Location = new System.Drawing.Point(635, 416);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(40, 24);
			this.buttonExit.TabIndex = 1;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonRun
			// 
			this.buttonRun.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonRun.Location = new System.Drawing.Point(584, 416);
			this.buttonRun.Name = "buttonRun";
			this.buttonRun.Size = new System.Drawing.Size(40, 23);
			this.buttonRun.TabIndex = 2;
			this.buttonRun.Text = "Run";
			this.buttonRun.Click += new System.EventHandler(this.buttonRun_Click);
			this.buttonRun.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// richTextIntro
			// 
			this.richTextIntro.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(244)))), ((int)(((byte)(255)))));
			this.richTextIntro.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextIntro.Location = new System.Drawing.Point(-1, 0);
			this.richTextIntro.Name = "richTextIntro";
			this.richTextIntro.ReadOnly = true;
			this.richTextIntro.Size = new System.Drawing.Size(565, 448);
			this.richTextIntro.TabIndex = 4;
			this.richTextIntro.Text = "";
			this.richTextIntro.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// labelQSize
			// 
			this.labelQSize.Location = new System.Drawing.Point(572, 40);
			this.labelQSize.Name = "labelQSize";
			this.labelQSize.Size = new System.Drawing.Size(112, 13);
			this.labelQSize.TabIndex = 5;
			this.labelQSize.Text = "Prime # Table Length";
			// 
			// labelRSize
			// 
			this.labelRSize.Location = new System.Drawing.Point(573, 96);
			this.labelRSize.Name = "labelRSize";
			this.labelRSize.Size = new System.Drawing.Size(112, 13);
			this.labelRSize.TabIndex = 6;
			this.labelRSize.Text = "Size of Results Table";
			// 
			// labelJLim
			// 
			this.labelJLim.Location = new System.Drawing.Point(573, 152);
			this.labelJLim.Name = "labelJLim";
			this.labelJLim.Size = new System.Drawing.Size(120, 13);
			this.labelJLim.TabIndex = 7;
			this.labelJLim.Text = "Primes Gen. Per Cycle";
			// 
			// textBoxQSize
			// 
			this.textBoxQSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxQSize.Location = new System.Drawing.Point(583, 56);
			this.textBoxQSize.Name = "textBoxQSize";
			this.textBoxQSize.Size = new System.Drawing.Size(80, 20);
			this.textBoxQSize.TabIndex = 8;
			this.textBoxQSize.Text = "10000";
			this.textBoxQSize.TextChanged += new System.EventHandler(this.textBoxQSize_TextChanged);
			this.textBoxQSize.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// textBoxRSize
			// 
			this.textBoxRSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxRSize.Location = new System.Drawing.Point(583, 112);
			this.textBoxRSize.Name = "textBoxRSize";
			this.textBoxRSize.Size = new System.Drawing.Size(80, 20);
			this.textBoxRSize.TabIndex = 9;
			this.textBoxRSize.Text = "500";
			this.textBoxRSize.TextChanged += new System.EventHandler(this.textBoxRSize_TextChanged);
			this.textBoxRSize.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// textBoxJLim
			// 
			this.textBoxJLim.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			this.textBoxJLim.Location = new System.Drawing.Point(583, 168);
			this.textBoxJLim.Name = "textBoxJLim";
			this.textBoxJLim.Size = new System.Drawing.Size(80, 20);
			this.textBoxJLim.TabIndex = 10;
			this.textBoxJLim.Text = "105000";
			this.textBoxJLim.TextChanged += new System.EventHandler(this.textBoxJLim_TextChanged);
			this.textBoxJLim.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// labelCyc
			// 
			this.labelCyc.Location = new System.Drawing.Point(574, 208);
			this.labelCyc.Name = "labelCyc";
			this.labelCyc.Size = new System.Drawing.Size(100, 13);
			this.labelCyc.TabIndex = 11;
			this.labelCyc.Text = "Cycles Per Status";
			// 
			// textBoxCyc
			// 
			this.textBoxCyc.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			this.textBoxCyc.Location = new System.Drawing.Point(581, 224);
			this.textBoxCyc.Name = "textBoxCyc";
			this.textBoxCyc.Size = new System.Drawing.Size(80, 20);
			this.textBoxCyc.TabIndex = 12;
			this.textBoxCyc.Text = "1";
			this.textBoxCyc.TextChanged += new System.EventHandler(this.textBoxCyc_TextChanged);
			this.textBoxCyc.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonDefault
			// 
			this.buttonDefault.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonDefault.Location = new System.Drawing.Point(573, 336);
			this.buttonDefault.Name = "buttonDefault";
			this.buttonDefault.Size = new System.Drawing.Size(104, 24);
			this.buttonDefault.TabIndex = 13;
			this.buttonDefault.Text = "Default Settings";
			this.buttonDefault.Click += new System.EventHandler(this.buttonDefault_Click);
			this.buttonDefault.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// textBoxPri
			// 
			this.textBoxPri.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			this.textBoxPri.Location = new System.Drawing.Point(582, 285);
			this.textBoxPri.Name = "textBoxPri";
			this.textBoxPri.Size = new System.Drawing.Size(80, 20);
			this.textBoxPri.TabIndex = 14;
			this.textBoxPri.Text = "-1";
			this.textBoxPri.TextChanged += new System.EventHandler(this.textBoxPri_TextChanged);
			this.textBoxPri.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// labelPri
			// 
			this.labelPri.Location = new System.Drawing.Point(576, 266);
			this.labelPri.Name = "labelPri";
			this.labelPri.Size = new System.Drawing.Size(96, 16);
			this.labelPri.TabIndex = 15;
			this.labelPri.Text = "Execution Priority";
			// 
			// StartupForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(692, 446);
			this.Controls.Add(this.labelPri);
			this.Controls.Add(this.textBoxPri);
			this.Controls.Add(this.buttonDefault);
			this.Controls.Add(this.textBoxCyc);
			this.Controls.Add(this.labelCyc);
			this.Controls.Add(this.textBoxJLim);
			this.Controls.Add(this.textBoxRSize);
			this.Controls.Add(this.textBoxQSize);
			this.Controls.Add(this.labelJLim);
			this.Controls.Add(this.labelRSize);
			this.Controls.Add(this.labelQSize);
			this.Controls.Add(this.richTextIntro);
			this.Controls.Add(this.buttonRun);
			this.Controls.Add(this.buttonExit);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "StartupForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Startup";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			this.Load += new System.EventHandler(this.StartupForm_Load);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new StartupForm());
		}

		private void Pr(string st)
		{
			richTextIntro.Text += "   " + st + "\n";
		}

		private void textBoxQSize_TextChanged(object sender, System.EventArgs e) // prime # Table Length
		{
			string sqSize = textBoxQSize.Text.TrimStart(' ');	// remove leading spaces
			textBoxQSize.Text = sqSize;							// from text box
			if (Global.IsInt32(sqSize))
			{
				int iQSize = System.Convert.ToInt32(sqSize);
				bqSize = (iQSize >= 1);
			}
			else
			{
				bqSize = false;
			}
			int n = sqSize.Length;
			if ((n > 0) && (sqSize.Substring(n-1, 1)== " ")) // remove spaces at end
			{
				sqSize = sqSize.TrimEnd(' ');
				textBoxQSize.Text = sqSize;
				textBoxQSize.SelectionStart = sqSize.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxRSize_TextChanged(object sender, System.EventArgs e) // size of Results Table
		{
			string srSize = textBoxRSize.Text.TrimStart(' ');	// remove leading spaces
			textBoxRSize.Text = srSize;							// from text box
			if (Global.IsInt32(srSize))
			{
				int iRSize = System.Convert.ToInt32(srSize);
				brSize = (iRSize >= 1);
			}
			else
			{
				brSize = false;
			}
			int n = srSize.Length;
			if ((n > 0) && (srSize.Substring(n-1, 1)== " ")) // remove spaces at end
			{
				srSize = srSize.TrimEnd(' ');
				textBoxRSize.Text = srSize;
				textBoxRSize.SelectionStart = srSize.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxJLim_TextChanged(object sender, System.EventArgs e) // primes Gen. Per Cycle
		{
			string sjLim = textBoxJLim.Text.TrimStart(' ');	// remove leading spaces
			textBoxJLim.Text = sjLim;						// from text box
			if (Global.IsInt32(sjLim))
			{
				int iJLim = System.Convert.ToInt32(sjLim);
				bjLim = (iJLim >= 2);
			}
			else
			{
				bjLim = false;
			}
			int n = sjLim.Length;
			if ((n > 0) && (sjLim.Substring(n-1, 1)== " ")) // remove spaces at end
			{
				sjLim = sjLim.TrimEnd(' ');
				textBoxJLim.Text = sjLim;
				textBoxJLim.SelectionStart = sjLim.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxCyc_TextChanged(object sender, System.EventArgs e) // cycles Per Status
		{
			string scyc = textBoxCyc.Text.TrimStart(' ');	// remove leading spaces
			textBoxCyc.Text = scyc;							// from text box
			if (Global.IsInt32(scyc))
			{
				int iCyc = System.Convert.ToInt32(scyc);
				bcyc = (1 <= iCyc && iCyc <= 1000);
			}
			else
			{
				bcyc = false;
			}
			int n = scyc.Length;
			if ((n > 0) && (scyc.Substring(n-1, 1)== " ")) // remove spaces at end
			{
				scyc = scyc.TrimEnd(' ');
				textBoxCyc.Text = scyc;
				textBoxCyc.SelectionStart = scyc.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxPri_TextChanged(object sender, EventArgs e) // execution priority
		{
			string spri = textBoxPri.Text.TrimStart(' ');	// remove leading spaces
			textBoxPri.Text = spri;							// from text box
			if (Global.IsInt32(spri))
			{
				int iPri = System.Convert.ToInt32(spri);
				bpri = (-2 <= iPri && iPri <= 2);
				if (bpri && (iPri != Global.pri)) Global.SetPriority(iPri);
			}
			else
			{
				bpri = false;
			}
			int n = spri.Length;
			if ((n > 0) && (spri.Substring(n - 1, 1) == " ")) // remove spaces at end
			{
				spri = spri.TrimEnd(' ');
				textBoxPri.Text = spri;
				textBoxPri.SelectionStart = spri.Length; // stay at end
			}
			SetFonts();
		}
		
		private void buttonDefault_Click(object sender, System.EventArgs e)
		{
			if (Global.pri != -1) Global.SetPriority(-1);
			SetDefault();
		}

		private void SetDefault()
		{
			textBoxQSize.Text = "10000";
			textBoxRSize.Text = "500";
			textBoxJLim.Text = "105000";
			textBoxCyc.Text = "1";
			textBoxPri.Text = Global.pri.ToString();
			buttonRun.Enabled = bqSize = brSize = bjLim = bcyc = bpri = true;
		}

		private void buttonRun_Click(object sender, System.EventArgs e)
		{
			int iQSize = System.Convert.ToInt32(textBoxQSize.Text);
			int iRSize = System.Convert.ToInt32(textBoxRSize.Text);
			int iJLim = System.Convert.ToInt32(textBoxJLim.Text);
			int iCyc = System.Convert.ToInt32(textBoxCyc.Text);
			int iPri = System.Convert.ToInt32(textBoxPri.Text);
			this.Hide();
			RunForm objRunForm = new RunForm();
			objRunForm.Show();
			flagAbort = false;
			objRunForm.Run(iQSize, iRSize, iJLim, iCyc, iPri, this);
			if (flagAbort) Dispose(true);
			textBoxPri.Text = Global.pri.ToString();
		}

		private void SetFonts()
		{
			if (bqSize)
				this.textBoxQSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxQSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (brSize)
				this.textBoxRSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxRSize.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bjLim)
				this.textBoxJLim.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxJLim.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bcyc)
				this.textBoxCyc.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxCyc.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bpri)
				this.textBoxPri.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxPri.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			buttonRun.Enabled = bqSize && brSize && bjLim && bcyc && bpri;
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		private void buttonRun_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape) // ESC key pressed so Exit Startup
			{
				Dispose(true);
			}
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Dispose(true);
		}

		private static bool bqSize;		// qSize good flag
		private static bool brSize;		// rSize good flag
		private static bool bjLim;		// jLim good flag
		private static bool bcyc;		// cyc good flag
		private static bool bpri;		// pri good flag

		public static bool flagAbort;

		private void StartupForm_Load(object sender, EventArgs e)
		{

		}	// set by runForm
	}
}
